/* [wb_pȈMIMEaGR[h                       */
/*                          Copyright(C)1998,1999 by T.Toda */
/* ͂̓VtgJISɌ^MIME̍s͑SCɂȂ    */
/* QoCgɑPoCg̉p͈ꏏɃGR[h */
/* pȊÔPoCgi󔒂܂ށj̓GR[hȂ */
#include <stdio.h>

#define	MIMEHEAD	"=?ISO-2022-JP?B?"
#define	MIMETAIL	"?="
#define	JISSTART	"\033$B"
#define	ASCSTART	"\033(B"

static	char	b_table[] 
	= "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
static	unsigned char	buffer[3] = {0, 0, 0};
static	int	bufptr = 0;
static	void	putb64(int), endb64(void), putsb64(char *);

int	main(int argc, char **argv, char **envp)
{
	FILE	*fp;
	int	c, c0, c1;
	static	char	k_table[] 
		= "@BuvAE@BDFHb[ACEGIJLNPRTVXZ\"
		  "^`cegijklmnqtwz}~JK";

	if( argc > 2 ){
		fputs("Usage : ", stderr);
		fputs(argv[0], stderr);
		fputs(" [infile]\n", stderr);
		return	4;
	}
	if( argc != 2 ){
		fp = stdin;
	}
	else if(( fp = fopen(argv[1],"r")) == NULL ){
		fputs("Can't Open '",stderr);
		fputs(argv[1],stderr);
		fputs("'.\n",stderr);
		return	8;
	}

	c = getc(fp);
	for(;;){
		for(;;){
			if( c == EOF ){
				return	0;
			}
			if( c & 0x80 )break;
			putchar(c);
			c = getc(fp);
		}
		fputs(MIMEHEAD, stdout);
		while( c & 0x80 && c != EOF ){
			putsb64(JISSTART);
			while( c & 0x80 && c != EOF ){
				if( c >= 0xa0 && c < 0xe0 ){
					c0 = k_table[( c - 0xa0 ) * 2];
					c1 = k_table[( c - 0xa0 ) * 2 + 1];
				}
				else{
					c0 = c;
					if(( c = getc(fp)) <= 0x20 ){
						c1 = 0x20;
					}
					else{
						c1 = c;
					}
				}
				c0 &= 0x3f;
				if( c0 >= 1 )c0--;
				c0 *= 2;
				c0 += 0x21;
				if( c1 & 0x80 )c1--;
				c1 -= 0x40;
				c0 += c1 / (0x7f - 0x21);
				c1 %= (0x7f - 0x21);
				putb64(c0);
				putb64(c1 + 0x21);
				if( c > 0x20 )c = getc(fp);
			}

			putsb64(ASCSTART);
			while(( c >= '0' && c <= '9' ) ||
			      ( c >= 'A' && c <= 'Z' ) ||
			      ( c >= 'a' && c <= 'z' )){
				putb64(c);
				c = getc(fp);
			}
		}
		endb64();
		fputs(MIMETAIL, stdout);
	}
}

static	void	putsb64(char *ptr)
{
	while( *ptr ){
		putb64( *ptr++ );
	}
}

static	void	putb64(int c)
{
	int	i;

	buffer[bufptr++] = c;
	if( bufptr >= 3 ){
		putchar(b_table[ ( buffer[0] >> 2 ) & 0x3f ]);
		putchar(b_table[ (( buffer[0] << 4 ) 
		              | ( buffer[1] >> 4 )) & 0x3f ]);
		putchar(b_table[ (( buffer[1] << 2 ) 
		              | ( buffer[2] >> 6 )) & 0x3f ]);
		putchar(b_table[ buffer[2] & 0x3f ]);
		for( i = 0 ; i < 3 ; i++ ){
			buffer[i] = 0;
		}
		bufptr = 0;
	}
}

static	void	endb64()
{
	int	i;

	if( bufptr > 0 ){
		putchar(b_table[  ( buffer[0] >> 2 )  & 0x3f ]);
		putchar(b_table[ (( buffer[0] << 4 ) 
		                | ( buffer[1] >> 4 )) & 0x3f ]);
		putchar( bufptr == 1 ? '=' : 
		        b_table[ (( buffer[1] << 2 ) 
		                | ( buffer[2] >> 6 )) & 0x3f ]);
		putchar('=');
		for( i = 0 ; i < 3 ; i++ ){
			buffer[i] = 0;
		}
		bufptr = 0;
	}
}
