/* Divide 'mbox' file into ones including each mail          */
/* Revised Version... file no.99 includes all the rest mails */
/*                          Copyright(c) 2002,2003 by T.Toda */
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>

static	int	opennextfile(void);

static	char	*namehead, *namebuf;
static	FILE	*fpout;

int	main(int argc, char **argv, char **envp)
{
	FILE	*fpin;
	int	c, c0 = 0, reach99;

	if( argc > 3 ){
		fputs("Usage : ", stderr);
		fputs(argv[0], stderr);
		fputs(" [infile [outfilenamehead]]\n", stderr);
		return	4;
	}
	if( argc < 2 ){
		fpin = stdin;
	}
	else if(( fpin = fopen(argv[1],"r")) == NULL ){
		fputs("Can't Open '",stderr);
		fputs(argv[1],stderr);
		fputs("'.\n",stderr);
		return	8;
	}
	namehead = ( argc < 3 ) ? "mbox" : argv[2];
	if(( namebuf = malloc(strlen(namehead) + 1 + 2 + 1)) == NULL ){
		fputs("Can't Allocate Memory.\n",stderr);
		return	8;
	}
	reach99 = opennextfile();
	while(( c = getc(fpin) ) != EOF ){
		if( c0 == '\n' && c == 'F' ){
			if(( c = getc(fpin)) != 'r' ){
				fputs("F", fpout);
				putc(c, fpout);
			}
			else if(( c = getc(fpin)) != 'o' ){
				fputs("Fr", fpout);
				putc(c, fpout);
			}
			else if(( c = getc(fpin)) != 'm' ){
				fputs("Fro", fpout);
				putc(c, fpout);
			}
			else if(( c = getc(fpin)) != ' ' ){
				fputs("From", fpout);
				putc(c, fpout);
			}
			else{
				fclose(fpout);
				reach99 = opennextfile();
				fputs("From ", fpout);
			}
		}
		else{
			putc(c, fpout);
		}
		c0 = c;
		if( reach99 ){
			while(( c = getc(fpin) ) != EOF ){
				putc(c, fpout);
			}
			break;
		}
	}
	fclose(fpout);
	return	0;
}

static	int	opennextfile()
{
	static	int	filenum = 0;
	int	namelen;

	strcpy(namebuf, namehead);
	namelen = strlen(namebuf);
	namebuf[namelen] = '.';
	namebuf[namelen+1] = '0' + filenum / 10;
	namebuf[namelen+2] = '0' + filenum % 10;
	namebuf[namelen+3] = 0;
	if(( fpout = fopen(namebuf, "r")) != NULL ){
		fputs("'",stderr);
		fputs(namebuf,stderr);
		fputs("' already exists.\n",stderr);
		exit(8);
	}
	if(( fpout = fopen(namebuf, "w")) == NULL ){
		fputs("Can't Open '",stderr);
		fputs(namebuf,stderr);
		fputs("'.\n",stderr);
		exit(8);
	}
	filenum++;
	return	(filenum > 99);
}
