/* Pickup mails with specified 'Envelope-From' from 'mbox' file */
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>

int	main(int argc, char **argv, char **envp)
{
	FILE	*fpin;
	FILE	*fpout;
	char	*comparebuf;
	int	comparelen;
	int	selected = 1;
	int	reverse = 0;
	int	i, c;
	int	c0 = '\n';

        while(( c = getopt(argc, argv, "r")) != EOF ){
                switch( c ){
                case 'r':
                        reverse = 1;
                        break;
                }
        }
	if( ( argc > optind + 3 ) || ( argc < optind + 1 ) ){
		fputs("Usage : ", stderr);
		fputs(argv[0], stderr);
		fputs(" [ -r ] fromaddress [infile [outfilename]]\n", stderr);
		return	4;
	}
        comparelen = strlen(argv[optind]);
        if(( comparebuf = malloc(comparelen + 1)) == NULL ){
                fputs("Can't Allocate Memory.\n", stderr);
                return  8;
        }
	if( argc < optind + 2 ){
		fpin = stdin;
	}
	else if(( fpin = fopen(argv[optind + 1],"r")) == NULL ){
		fputs("Can't Open '", stderr);
		fputs(argv[optind + 1], stderr);
		fputs("'.\n", stderr);
		return	8;
	}
	if( argc < optind + 3 ){
		fpout = stdout;
	}
	else{
		if(( fpout = fopen(argv[optind + 2],"r")) != NULL ){
			fputs("File '", stderr);
			fputs(argv[optind + 2], stderr);
			fputs("' Exists. Overwrite? (Y/N)", stderr);
                	gets(comparebuf);
                	if( comparebuf[0] != 'Y' && comparebuf[0] != 'y' ){
                        	return	4;
			}
			fclose(fpout);
		}
		if(( fpout = fopen(argv[optind + 2],"w")) == NULL ){
			fputs("Can't Open '", stderr);
			fputs(argv[optind + 2], stderr);
			fputs("'.\n", stderr);
			return	8;
		}
	}
	while(( c = getc(fpin) ) != EOF ){
		if( c0 == '\n' && c == 'F' ){
			if(( c = getc(fpin)) != 'r' ){
				if( selected ){
					fputs("F", fpout);
					putc(c, fpout);
				}
			}
			else if(( c = getc(fpin)) != 'o' ){
				if( selected ){
					fputs("Fr", fpout);
					putc(c, fpout);
				}
			}
			else if(( c = getc(fpin)) != 'm' ){
				if( selected ){
					fputs("Fro", fpout);
					putc(c, fpout);
				}
			}
			else if(( c = getc(fpin)) != ' ' ){
				if( selected ){
					fputs("From", fpout);
					putc(c, fpout);
				}
			}
			else{
				for( i = 0 ; i < comparelen ; i++ ){
					c = getc(fpin);	
					comparebuf[i] = c;
					if( c < ' ' ){
						comparebuf[i++] = 0;
						break;
					}
				}
				comparebuf[i] = 0;
				selected = strcmp(comparebuf, argv[optind]) == 0;
				if( reverse ){
					selected = !selected;
				}
				if( selected ){
					fputs("From ", fpout);
					fputs(comparebuf, fpout);
				}
			}
		}
		else{
			if( selected ){
				putc(c, fpout);
			}
		}
		c0 = c;
	}
	fclose(fpout);
	return	0;
}
