/* Divide file by lines including specified string */
/* (developed to divide mail file to MIME parts)   */
/*                      Copyright(c)2002 by T.Toda */
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>

#define	BUFSIZE	32768

static	void	opennextfile(void);

static	char	*namehead, *namebuf;
static	FILE	*fpout;

int	main(int argc, char **argv, char **envp)
{
	FILE	*fpin;
	char	*linebuf;
	int	linesize;

	if( argc > 4 ){
		fputs("Usage : ", stderr);
		fputs(argv[0], stderr);
		fputs(" keystring [infile [outfilenamehead]]\n", stderr);
		return	4;
	}
	if( argc < 3 ){
		fpin = stdin;
	}
	else if( (fpin = fopen(argv[2],"r")) == NULL ){
		fputs("Can't Open '",stderr);
		fputs(argv[2],stderr);
		fputs("'.\n",stderr);
		return	8;
	}
	if( ( namebuf = malloc(BUFSIZE)) == NULL ){
		fputs("Can't Allocate Memory.\n",stderr);
		return	8;
	}
	namehead = ( argc < 4 ) ? "part" : argv[3];
	linesize = sizeof(namehead) + 1 + 2 + 1;
	linebuf = namebuf + linesize;
	linesize = BUFSIZE - linesize;
	opennextfile();
	while( fgets(linebuf, linesize, fpin) ){
		if( strstr(linebuf, argv[1]) ){
			fclose(fpout);
			opennextfile();
		}
		else{
			fputs(linebuf, fpout);
		}
	}
	fclose(fpout);
	return	0;
}

static	void	opennextfile()
{
	static	int	filenum = 0;
	int	namelen;

	strcpy(namebuf, namehead);
	namelen = strlen(namebuf);
	namebuf[namelen] = '.';
	namebuf[namelen+1] = '0' + filenum / 10;
	namebuf[namelen+2] = '0' + filenum % 10;
	namebuf[namelen+3] = 0;
	if(( fpout = fopen(namebuf, "r")) != NULL ){
		fputs("'",stderr);
		fputs(namebuf,stderr);
		fputs("' already exists.\n",stderr);
		exit(8);
	}
	if(( fpout = fopen(namebuf, "w")) == NULL ){
		fputs("Can't Open '",stderr);
		fputs(namebuf,stderr);
		fputs("'.\n",stderr);
		exit(8);
	}
	filenum++;
}
