/* [wb_pMIMEGR[hiB&Qj̓WJ */
/*           Copyright(C)2000,2001 by T.Toda */
#include <stdio.h>

#ifdef	MSDOS
#define	OPENMODE	"wb"
#else
#define	OPENMODE	"w"
#endif

#define	BUFLEN	16

int	main(int argc, char **argv, char **envp)
{
	FILE	*fpin, *fpout;
	int	c = 0, c0, c1, i, bufptr;
	unsigned char	cnvbuf[4];
	int	headbuf[BUFLEN];

	if( argc > 3 ){
		fputs("Usage : ", stderr);
		fputs(argv[0], stderr);
		fputs(" [infile [outfile]]\n", stderr);
		return	4;
	}
	if( argc < 2 ){
		fpin = stdin;
	}
	else if(( fpin = fopen(argv[1],"r")) == NULL ){
		fputs("Can't Open '",stderr);
		fputs(argv[1],stderr);
		fputs("'.\n",stderr);
		return	8;
	}
	if( argc < 3 ){
		fpout = stdout;
	}
	else if(( fpout = fopen(argv[2],OPENMODE)) == NULL ){
		fputs("Can't Open '",stderr);
		fputs(argv[2],stderr);
		fputs("'.\n",stderr);
		return	8;
	}

	while( (c = getc(fpin)) != EOF ){

		/* Skip until MIME-B/Q Start Sequence */
		if( c != '=' ){
			putc(c, fpout);
			continue;
		}
		c = getc(fpin);
		while( c == '=' ){
			putc('=', fpout);
			c = getc(fpin);
		}
		if( c == EOF ){
			putc('=', fpout);
			break;
		}
		if( c != '?' ){
			putc('=', fpout);
			putc(c, fpout);
			continue;
		}
		bufptr = 0;
		while( (c = getc(fpin)) != '?' ){
			if( c == EOF )break;
			headbuf[bufptr++] = c;
			if( bufptr >= BUFLEN )break;
			if( c <= ' ' )break;
			if( c >= 0x7f )break;
		}
		if( c != '?' ){
			putc('=', fpout);
			putc('?', fpout);
			for( i = 0 ; i < bufptr ; i++ ){
				putc(headbuf[i], fpout);
			}
			continue;
		}
		c0 = getc(fpin);
		if( c0 != 'B' && c0 != 'b' && c0 != 'Q' && c0 != 'q' ){
			putc('=', fpout);
			putc('?', fpout);
			for( i = 0 ; i < bufptr ; i++ ){
				putc(headbuf[i], fpout);
			}
			putc('?', fpout);
			if( c0 != EOF )putc(c0, fpout);
			continue;
		}
		if( (c = getc(fpin)) != '?' ){
			putc('=', fpout);
			putc('?', fpout);
			for( i = 0 ; i < bufptr ; i++ ){
				putc(headbuf[i], fpout);
			}
			putc('?', fpout);
			putc(c0, fpout);
			if( c != EOF )putc(c, fpout);
			continue;
		}

		/* Decode MIME-B */
		if( c0 == 'B' || c0 == 'b' ){
			i = 0;
			c = 'B';
			while( c == 'B' ){
				c0 = getc(fpin);
				if( c0 >= 'A' && c0 <= 'Z' ){
					cnvbuf[i++] = c0 - 'A';
				}
				else if( c0 >= 'a' && c0 <= 'z' ){
					cnvbuf[i++] = c0 + 26 - 'a';
				}
				else if( c0 >= '0' && c0 <= '9' ){
					cnvbuf[i++] = c0 + 52 - '0';
				}
				else if( c0 == '+' ){
					cnvbuf[i++] = 62;
				}
				else if( c0 == '/' ){
					cnvbuf[i++] = 63;
				}
				else{
					c = c0;
				}
				if( i >= 4 || c != 'B' ){
					if( i >= 2 )putc( (int)(( cnvbuf[0] << 2 ) | ( cnvbuf[1] >> 4 )), fpout);
					if( i >= 3 )putc( (int)(( cnvbuf[1] << 4 ) | ( cnvbuf[2] >> 2 )), fpout);
					if( i >= 4 )putc( (int)(( cnvbuf[2] << 6 ) | cnvbuf[3]), fpout);
					i = 0;
				}
			}

			/* Skip MIME-B Terminate Sequence */
			while( c == '=' ){
				c = getc(fpin);
			}
			if( c == '?' ){
				c = getc(fpin);
			}
			if( c == '=' ){
				c = EOF;
			}
			if( c != EOF ){
				putc(c, fpout);
			}
		}

		/* Decode MIME-Q */
		else while(( c = getc(fpin) ) != EOF ){
			if( c == '?' ){
				if(( c0 = getc(fpin) ) == '=' )break;
				putc(c, fpout);
				c = c0;
			}
			if( c == '=' ){
				c0 = getc(fpin);
				if( c0 >= '0' && c0 <= '9' ){
					c = c0 - '0';
				}
				else if( c0 >= 'A' && c0 <= 'F' ){
					c = c0 - 'A' + 10;
				}
				else if( c0 >= 'a' && c0 <= 'f' ){
					c = c0 - 'a' + 10;
				}
				else if( c0 == '\n' ){
					continue;
				}
				else{
					putc(c0, fpout);
					continue;
				}
				c1 = getc(fpin);
				if( c1 >= '0' && c1 <= '9' ){
					c *= 16;
					c += c1 - '0';
				}
				else if( c1 >= 'A' && c1 <= 'F' ){
					c *= 16;
					c += c1 - 'A' + 10;
				}
				else if( c1 >= 'a' && c1 <= 'f' ){
					c *= 16;
					c += c1 - 'a' + 10;
				}
				else{
					putc(c0, fpout);
					putc(c1, fpout);
					continue;
				}
				putc(c, fpout);
			}
			else{
				putc(c, fpout);
			}
		}
	}
	return	0;
}
